commit f5840677c146e4317d7fd53697dda60c616d3e58
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Sep 20 22:41:48 2022 +0200

    Fortran: error recovery on invalid ARRAY argument to FINDLOC [PR106986]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/106986
            * simplify.c (gfc_simplify_findloc): Do not try to simplify
            intrinsic FINDLOC when the ARRAY argument has a NULL shape.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/106986
            * gfortran.dg/pr106986.f90: New test.
    
    (cherry picked from commit 5976fbf9d5dd9542fcb82eebb2185886fd52d000)

diff --git a/gcc/fortran/simplify.c b/gcc/fortran/simplify.c
index b3d73935771..149353ef784 100644
--- a/gcc/fortran/simplify.c
+++ b/gcc/fortran/simplify.c
@@ -5757,6 +5757,7 @@ gfc_simplify_findloc (gfc_expr *array, gfc_expr *value, gfc_expr *dim,
   bool back_val = false;
 
   if (!is_constant_array_expr (array)
+      || array->shape == NULL
       || !gfc_is_constant_expr (dim))
     return NULL;
 
diff --git a/gcc/testsuite/gfortran.dg/pr106986.f90 b/gcc/testsuite/gfortran.dg/pr106986.f90
new file mode 100644
index 00000000000..a309b25d181
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr106986.f90
@@ -0,0 +1,8 @@
+! { dg-do compile }
+! PR fortran/106986 - ICE in simplify_findloc_nodim
+! Contributed by G.Steinmetz
+
+program p
+  integer, parameter :: a(:) = [1] ! { dg-error "deferred shape" }
+  print *, findloc (a, 1)
+end

